/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package servlet;

import java.io.IOException;
import java.io.PrintWriter;
import java.sql.Connection;
import java.sql.SQLException;
import javax.naming.InitialContext;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.sql.DataSource;

/**
 *
 * @author zhaojy
 */
public class Test extends HttpServlet {
   
    /** 
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        response.setContentType("text;charset=UTF-8");
        PrintWriter out = response.getWriter();
        try {
            Connection connectin = null;
            try{
                out.println( "================In this test, you should set LazyAssociation to true first.===================");
                connectin = ((DataSource)new InitialContext().lookup("jdbc/sample")).getConnection();
                out.println( "get Connection from jdbc/sample.");

                Class ConnectionHolder = connectin.getClass().getClassLoader().loadClass("com.sun.gjc.spi.base.ConnectionHolder");

                out.println( "do nothing but get the managed connection and physical connection.");

                out.println( "Managed Connection: " + ConnectionHolder.getDeclaredMethod("getManagedConnection").invoke(connectin) );
                out.println( "Actual Connection: " + ConnectionHolder.getDeclaredMethod("getConnection").invoke(connectin) );

            } catch (Exception exception) {
                exception.printStackTrace(out);
            } finally{
                try {
                    if (connectin != null && !connectin.isClosed()) {
                        connectin.close();
                    }
                } catch (SQLException ex) {
                    ex.printStackTrace(out);
                }
            }
        } finally {
            out.close();
        }
    } 

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /** 
     * Handles the HTTP <code>GET</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    } 

    /** 
     * Handles the HTTP <code>POST</code> method.
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
    throws ServletException, IOException {
        processRequest(request, response);
    }

    /** 
     * Returns a short description of the servlet.
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
